package com.jiuqi.util;

import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;

public class BitMatrix {
   private List bits = new ArrayList();

   public void clear() {
      for(int i = 0; i < this.bits.size(); ++i) {
         this.bits.set(i, (Object)null);
      }

   }

   public boolean get(int x, int y) {
      BitSet bs = y < this.bits.size() ? (BitSet)this.bits.get(y) : null;
      return bs != null && x < bs.size() ? bs.get(x) : false;
   }

   public void set(int x, int y, boolean value) {
      while(this.bits.size() <= y) {
         this.bits.add((Object)null);
      }

      BitSet bs = (BitSet)this.bits.get(y);
      if (bs == null) {
         if (!value) {
            return;
         }

         bs = new BitSet();
         this.bits.set(y, bs);
      }

      if (value) {
         bs.set(x);
      } else {
         bs.clear(x);
      }

   }

   public boolean hasTrue(int y) {
      if (y >= this.bits.size()) {
         return false;
      } else {
         BitSet bs = (BitSet)this.bits.get(y);
         if (bs == null) {
            return false;
         } else {
            Method nextSetBit = null;

            try {
               Class[] parameterTypes = new Class[]{Integer.TYPE};
               nextSetBit = bs.getClass().getMethod("nextSetBit", parameterTypes);
               if (nextSetBit != null) {
                  Object[] parameters = new Object[]{new Integer(0)};
                  if ((Integer)nextSetBit.invoke(bs, parameters) >= 0) {
                     return true;
                  }

                  return false;
               }
            } catch (Exception var6) {
               Exception ex = var6;
               ex.printStackTrace();
            }

            for(int i = 0; i < bs.size(); ++i) {
               if (bs.get(i)) {
                  return false;
               }
            }

            return true;
         }
      }
   }

   public static void main(String[] args) {
      BitMatrix bm = new BitMatrix();
      bm.set(100, 1, true);
      System.out.println(bm.hasTrue(0));
      System.out.println(bm.hasTrue(1));
   }
}
